#property copyright "copyleft mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 DimGray
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_style1 STYLE_DOT

//
//
//
//
//

extern int    BandsLength    = 20;
extern double BandsDeviation = 2.0;
extern int    BandsPrice     = PRICE_MEDIAN;

double MaBuffer[];
double UpperBand[];
double LowerBand[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0,MaBuffer);
   SetIndexBuffer(1,UpperBand);
   SetIndexBuffer(2,LowerBand);
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //

   for (int i=limit;i>=0;i--)
      {
         double deviation = iStdDev(NULL,0,BandsLength,0,MODE_SMA,BandsPrice,i);
         MaBuffer[i]  = iMA(NULL,0,BandsLength,0,MODE_SMA,BandsPrice,i);
         UpperBand[i] = MaBuffer[i]+BandsDeviation*deviation;
         LowerBand[i] = MaBuffer[i]-BandsDeviation*deviation;
      }            
   return(0);
}